/*  $Id: zip_local_file_header.cpp,v 1.5 2003/07/20 22:30:53 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#include "Core/precomp.h"
#include "zip_local_file_header.h"
#include "API/Core/IOData/inputsource.h"
#include "API/Core/IOData/outputsource.h"

/////////////////////////////////////////////////////////////////////////////
// CL_Zip_LocalFileHeader construction:

CL_Zip_LocalFileHeader::CL_Zip_LocalFileHeader()
{
	signature = 0x04034b50;
}
	
CL_Zip_LocalFileHeader::~CL_Zip_LocalFileHeader()
{
}

/////////////////////////////////////////////////////////////////////////////
// CL_Zip_LocalFileHeader attributes:

	
/////////////////////////////////////////////////////////////////////////////
// CL_Zip_LocalFileHeader operations:

void CL_Zip_LocalFileHeader::load(CL_InputSource *input)
{
	signature = input->read_int32();
	if (signature != 0x04034b50)
	{
		throw CL_Error("Incorrect Local File Header signature");
	}
	version_needed_to_extract = input->read_int16();
	general_purpose_bit_flag = input->read_int16();
	compression_method = input->read_int16();
	last_mod_file_time = input->read_int16();
	last_mod_file_date = input->read_int16();
	crc32 = input->read_int32();
	compressed_size = input->read_int32();
	uncompressed_size = input->read_int32();
	file_name_length = input->read_int16();
	extra_field_length = input->read_int16();
	char *str1 = new char[file_name_length];
	char *str2 = new char[extra_field_length];
	try
	{
		input->read(str1, file_name_length);
		input->read(str2, extra_field_length);
		filename = std::string(str1, file_name_length);
		extra_field = std::string(str2, extra_field_length);

		delete[] str1;
		delete[] str2;
	}
	catch (...)
	{
		delete[] str1;
		delete[] str2;
		throw;
	}
}
	
void CL_Zip_LocalFileHeader::save(CL_OutputSource *output)
{
}
	
/////////////////////////////////////////////////////////////////////////////
// CL_Zip_LocalFileHeader implementation:
